;;;;;;;;;;;;;-------LICENSE NOTICE-----------;;;;;;;;;;;;;;;
;; MIT License

;; Copyright (c) 2021 DreamyZombies Studio

;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:

;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.

;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.
;;
;; Authors:
;;  Abderrahamane Guermat Benaouali (agb139@alu.ua.es)
;;  Jorge Angulo Espí (jae17@alu.ua.es)
;;  Sami Hadj-Djilani (sh101@alu.ua.es)



;;
;; MAIN FUNCTION
;;

.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "man/input.h.s"
.include "man/player.h.s"
.include "man/game.h.s"
.include "man/interruptions.h.s"
.include "sys/physics.h.s"
.include "sys/music.h.s"
.include "sys/render.h.s"
   
.area _DATA

.area _CODE

_main::

   ;; MUSIC INIT
   call set_music_menu
   call set_music_fx
   call set_int_handler

   ;; RENDER INIT
   call renderSys_init

   ;; MENU
   call loadMenu
   jp z, exit

   ;; FIRST SCREEN
   call renderSys_white
   call game_manager_init_lobby
   call stop_music
   call set_music_world

   ;; GAME LOOP
   loop::

      call renderSys_update

      call entityman_getHero_pos
      call user_input

      call entityman_getHero_pos
      call sys_update_entities

      call cpct_waitVSYNC_asm
         
      jp loop

   ;; FORCE EXIT
   exit:

      ld a, #0xFFFF
      push af
      
      ret