;;;;;;;;;;;;;-------LICENSE NOTICE-----------;;;;;;;;;;;;;;;
;; MIT License

;; Copyright (c) 2021 DreamyZombies Studio

;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:

;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.

;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.
;;
;; Authors:
;;  Abderrahamane Guermat Benaouali (agb139@alu.ua.es)
;;  Jorge Angulo Espí (jae17@alu.ua.es)
;;  Sami Hadj-Djilani (sh101@alu.ua.es)


;;
;; INTERRUPTION MANAGER
;;

.include "sys/music.h.s"
.include "cpct_functions.h.s"


;; LOOP COUNT
times: .db 06

int_handler::
      
   push af
   push bc
   push de
   push hl

   ld a, (times)
   dec a
   jr nz, _cont

_zero:
  
   call update_music
   ld a, #6

_cont: 
   
   ld (times), a

   pop hl
   pop de
   pop bc
   pop af

   ei
   reti

set_int_handler::

   call cpct_waitVSYNC_asm
   halt 
   halt 
   call cpct_waitVSYNC_asm
   
   ld hl, #0x38
   ld (hl), #0xC3
   inc hl
   ld (hl), #<int_handler
   inc hl
   ld (hl), #>int_handler
   inc hl
   ld (hl), #0xC9

   ret